/** PgvOB
 *@ E
 *   bc=0    Dirichlet E
 *   bc=1    Neumann   E
 *   bc=2    iq_p@
 *
 *   RpCɂMitsuiWorldKvłB
 *   MitsuiWorldgԂłΕʂ̃RpC javac Wave1d.java
 *   ƕʂ̋N@ appletviewer Wave1d.java 
 *   łnjB
 *    appletviewer Wave1d.java Ƃ΃Rĝǂ
 *   
 *   <applet code = Wave1d width=500 height=500></applet>
 *   
 *   Ƃ̂ĂȂƂȂB
 *   MitsuiWorld̎gɂĂ
 *
 *   import Mitsui.*;
 *
 *   ƁB
 *   MitsuiWorldpbP[WƂĎgȂl͂ĂB
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import Mitsui.*;           //MitsuiWorld̓ĂpbP[WMitsuiĂяo

public class Wave1d extends Applet {
    int nfunc=0;                    //łǂ̊֐I񂾂fB
    int bc=0;                       //łǂ̋EI񂾂fB
    MitsuiWorld_2 m = new MitsuiWorld_2();

    public void init(){
        Graphics g=getGraphics();
        m.setGraphics(g);
        m.setScreenSize(getSize().width,getSize().height);
        //mCn~mCn
        m.setArea(-0.2,1.2,-1.2,1.2);
    }

    public void paint(Graphics g){
        //OAPA|PAA\
        g.setColor(Color.red);
        g.drawString("0",55,getSize().height/2+5);
        g.drawString("1",55,45);
        g.drawString("-1",55,465);
        g.drawString("x",440,245);
        g.drawString("y",80,30);

        //I񂾊֐̕\
        switch(nfunc){
        case 0:
            g.drawString("=sin(x),=0",20,20);
            break;
        case 1:
            g.drawString("=0(x<=3/8, 8x-3(3/8<x<=1/2, -8x+5(1/2<x<=5/8), 0(5/8<x), =0",20,20);
            break;
        case 2:
            g.drawString("ʔg",20,20);
            break;
        case 3:
            g.drawString("ʔg̍",20,20);
            break;
        }

        int n = 200;
        double lambda = 1.0;
        double Tmax = 4.0;
        
        double lambda2 = lambda * lambda;
        double h = 1.0/n;
        double tau = lambda * h;             
        
        double[] u1 = new double[n+1];
        double[] u2 = new double[n+1];
        double[] u3 = new double[n+1];
        
        //l
        //phi=
        //psi=
        for(int i=0;i<=n;i++)
            u1[i] = phi(i*h); 
        for(int i=1;i<n;i++)
            u2[i] = (1-lambda2) * u1[i] + 
                0.5 * lambda2 * (u1[i-1]+u1[i+1]) + tau * psi(i*h);
        
        if(bc==0){
            u2[0]=u2[n]=0;                       //DirichletE
        }
        if(bc==1){                               //NeumannE
            u2[0]=u2[1];
            u2[n]=u2[n-1];
        }
        if(bc==2){                               //ziq_
            u2[0] = (1-lambda2) * u1[0] + 
                0.5 * lambda2 * (2*u1[1]) + tau * psi(0.0);
            u2[n] = (1-lambda2) * u1[n] + 
                0.5 * lambda2 * (2*u1[n-1]) + tau * psi(n*h);
        }
                
        //j=0@ł̃Ot
        m.setColor(0);                           //black
        drawAxis();
        m.setColor(2);
        m.move(0.0,u1[0]);
        for(int i=1;i<=n;i++)
            m.draw(i*h,u1[i]);
        
        //t=0@ł̃OtB
        m.setColor(getBackground());
        m.move(0.0,u1[0]);
        for(int i=1;i<=n;i++)
            m.draw(i*h,u1[i]);
        
        //t=с@ł̃Ot
        m.setColor(0);
        drawAxis();
        m.setColor(2);
        m.move(0.0,u2[0]);
        for(int i=1;i<=n;i++)
            m.draw(i*h,u2[i]);
        
        int jmax = (int)Math.rint(Tmax/tau);
        for(int j=1;j<=jmax;j++){
            for(int i=1;i<n;i++)
                u3[i] = 2 * (1.0-lambda2) * u2[i] + 
                    lambda2 * (u2[i-1]+u2[i+1]) - u1[i];
            
            if(bc==0){                           //DirichletE
                u3[0] = u3[n] = 0;
            }
            if(bc==1){                          //NeumannE 
                u3[0]=u3[1];
                u3[n]=u3[n-1];
            }
            if(bc==2){                          //ziq_
                u3[0] = 2 * (1.0-lambda2) * u2[0] + 
                    lambda2 * (2*u2[1]) - u1[0];
                u3[n] = 2 * (1.0-lambda2) * u2[n] + 
                    lambda2 * (2*u2[n-1]) - u1[n];
            }
            
            //OtB
            m.setColor(getBackground());
            m.move(0.0,u2[0]);
            for(int i=1;i<=n;i++)
                m.draw(i*h,u2[i]);
            
            //t=j(j=>2)̃Ot
            m.setColor(0);
            drawAxis();
            m.setColor(2);
            m.move(0.0,u3[0]);
            for(int i=1;i<=n;i++)
                m.draw(i*h,u3[i]);
            
            for(int i=0;i<n;i++)
                u1[i] = u2[i];
            for(int i=0;i<n;i++)
                u2[i] = u3[i];
        }
    }

    //lӂ̊֐
    public double phi(double x){
        if(nfunc == 0){
            return Math.sin(Math.PI*x);
        }
        if(nfunc == 1){
            if(0.375<x && x<=0.5)
                return 8.0*x-3.0;
            if(0.5<x && x<=0.625)
                return -8.0*x+5.0;
            else 
                return 0.0;
        }
        if(nfunc == 2){
            if(0.0<=x && x<=0.2)
                return (Math.sin(Math.PI*(x*10-0.5))+1)/4;
            else
                return 0.0;
        }
        if(nfunc == 3){
            if(0.0<=x && x<=0.2)
                return (Math.sin(Math.PI*(x*10-0.5))+1)/4;
            if(0.9<=x && x<=1.0)
                return (Math.sin(Math.PI*((x-0.9)*20-0.5))+1)/8;
            else
                return 0.0;
        }
        else
            return 0.0;
    }

    //Ղ̊֐
    public double psi(double x){
        if(nfunc == 0){
            return 0.0;
        }
        if(nfunc == 1){
            return 0.0;
        }
        if(nfunc == 2){
            if(0.0<=x && x<=0.2)
                return -2.5*Math.PI*Math.cos(Math.PI*(10*x-0.5));
            else
                return 0.0;
        }
        if(nfunc == 3){
            if(0.0<=x && x<=0.2)
                return -2.5*Math.PI*Math.cos(Math.PI*(10*x-0.5));
            if(0.9<=x && x<=1.0)
                return 2.5*Math.PI*Math.cos(Math.PI*((x-0.9)*20-0.5));
            else
                return 0.0;
        }
        else
            return 0.0;
    }

   

    public void drawAxis(){
        //Wݒ
        m.move(0.0,0.0); m.draw(1.025,0.0);
        for(double x=0.0;x<=1.0;x+=0.1){
            m.move(x,0.025); m.draw(x,-0.025);
        }
        m.move(0.0,1.05); m.draw(0.0,-1.05);
        for(double y=1.0;y>=-1;y-=0.2){
            m.move(-0.01,y); m.draw(0.01,y);
        }
    }
}






