//<applet code = Wave3d_test width=500 height=500></applet>

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import Mitsui.*;

public class Wave3d_test extends Applet implements ActionListener,Runnable{
    Button b_start ,b_stop;
    Thread th = null;
    boolean runmove=false;                        //thread̏

    int t;
    int wmax,hmax;

    Graphics bg;
    Image buf;

    MitsuiWorld_2 m;
    double xmin,xmax,ymin,ymax,zmin,zmax;
    int nx,ny,nz;
    double dx,dy,dz;

    int n=50;
    double[][][] u1 = new double[n+1][n+1][n+1];
    double[][][] u2 = new double[n+1][n+1][n+1];
    double[][][] u3 = new double[n+1][n+1][n+1];

    public void init(){
	b_start = new Button("start");
	b_start.addActionListener(this);
	add(b_start);

	b_stop = new Button("stop");
	b_stop.addActionListener(this);
	add(b_stop);

	wmax = getSize().width;
	hmax = getSize().height;
	buf = createImage(wmax,hmax);
	bg = buf.getGraphics();

	xmin = -2.0;
	xmax = 2.5;
	ymin = -2.0;
	ymax = 2.5;
	zmin = -1.0;
	zmax = 1.0;
	m = new MitsuiWorld_2();
	m.setGraphics(bg);
	m.setScreenSize(wmax,hmax);
	m.setArea2(xmin,xmax,ymin,ymax,zmin,zmax);

	nx = 40;
	ny = 40;
	nz = 40;
	dx = (xmax-xmin)/nx;
	dy = (ymax-ymin)/ny;
	dz = (zmax-zmin)/nz;
    }

    public void start(){
	if(th==null){
	    th = new Thread(this);
	    th.start();
	}
    }

    public void run(){
	while(true){
	    while(!runmove){
	    }
	    t++;
	    double[][][] u = f(t);
	    bg.clearRect(0,0,wmax,hmax);
	    m.hideBirdView(u[nz/2],nx,ny,1);
	    repaint();
	    try{
		Thread.sleep(100);          //100~bXgbv
	    }catch(InterruptedException e){}
	}
    }
    
    public void stop(){
	if(th!=null){
	    th=null;
	}
    }

    public void actionPerformed(ActionEvent e){
	if(e.getSource()==b_start){
	    runmove=true;                //ĂуOt`n߂
	}
	
	//stop{^Ƃ̃ANV
	if(e.getSource()==b_stop){
	    if(!runmove){                          //ꎞ~̂Ƃ
		t=0;
		repaint();
	    }
	    else{                                 //ňꎞ~ 
		runmove=false;
	    }
	}
    }
    
    public void paint(Graphics g){
	if(t==0){
	    double[][][] u = f(t);
	    m.setColor(7);
	    bg.clearRect(0,0,wmax,hmax);
	    m.hideBirdView(u[nz/2],nx,ny,1);
	}
	g.drawImage(buf,0,0,this);
    }

    public double[][][] f(int t){
	double tau = 0.01;

	double lambdax = tau/dx;
	double lambday = tau/dy;
	double lambdaz = tau/dz;
	
	double lambdax2 = lambdax * lambdax;
	double lambday2 = lambday * lambday;
	double lambdaz2 = lambdaz * lambdaz;

	if(t==0){
	    for(int k=0;k<=nz;k++)
		for(int i=0;i<=nx;i++)
		    for(int j=0;j<=ny;j++)
			u1[k][i][j] = phi(xmin+i*dx,ymin+j*dy,zmin+k*dz);
	    return u1;
	}

	if(t==1){
	    for(int k=1;k<nz;k++)
		for(int i=1;i<nx;i++)
		    for(int j=1;j<ny;j++)
		     u2[k][i][j]=(1.0-lambdax2-lambday2-lambdaz2)*u1[k][i][j]+ 
			 0.5 * lambdax2 * (u1[k][i-1][j]+u1[k][i+1][j]) +
			 0.5 * lambday2 * (u1[k][i][j-1]+u1[k][i][j+1]) +
			 0.5 * lambdaz2 * (u1[k-1][i][j]+u1[k+1][i][j]) +
			 tau * psi(xmin+i*dx,ymin+j*dy,zmin+k*dz);
	    
	    //E
	    for(int i=0;i<=nx;i++){
		for(int j=0;j<=ny;j++){
		    u2[0][i][j] = u2[1][i][j];
		    u2[nz][i][j]= u2[nz-1][i][j];
		}
	    }
	    for(int j=0;j<=ny;j++){
		for(int k=0;k<=nz;k++){
		    u2[k][0][j] = u2[k][1][j];
		    u2[k][nx][j]= u2[k][nx-1][j];
		}
	    }
	    for(int k=0;k<=nz;k++){
		for(int i=0;i<=nx;i++){
		    u2[k][i][0] = u2[k][i][1];
		    u2[k][i][ny]= u2[k][i][ny-1];
		}
	    }
	    return u2;
	}

	else{
	    for(int k=1;k<nz;k++)
		for(int i=1;i<nx;i++)
		    for(int j=1;j<ny;j++)
		   u3[k][i][j]=2*(1.0-lambdax2-lambday2-lambdaz2)*u2[k][i][j]+ 
		       lambdax2 * (u2[k][i-1][j]+u2[k][i+1][j]) +
		       lambday2 * (u2[k][i][j-1]+u2[k][i][j+1]) +
		       lambdaz2 * (u2[k-1][i][j]+u2[k+1][i][j]) - u1[k][i][j];

	    //E
	    for(int i=0;i<=nx;i++){
		for(int j=0;j<=ny;j++){
		    u3[0][i][j] = u3[1][i][j];
		    u3[nz][i][j]= u3[nz-1][i][j];
		}
	    }
	    for(int j=0;j<=ny;j++){
		for(int k=0;k<=nz;k++){
		    u3[k][0][j] = u3[k][1][j];
		    u3[k][nx][j]= u3[k][nx-1][j];
		}
	    }
	    for(int k=0;k<=nz;k++){
		for(int i=0;i<=nx;i++){
		    u3[k][i][0] = u3[k][i][1];
		    u3[k][i][ny]= u3[k][i][ny-1];
		}
	    }
	    
	    //z
	    for(int k=0;k<=nz;k++){
		for(int i=0;i<=nx;i++){
		    for(int j=0;j<=ny;j++){
			u1[k][i][j] = u2[k][i][j];
			u2[k][i][j] = u3[k][i][j];
		    }
		}
	    }
	    return u3;
	}
    }

    public double phi(double x,double y,double z){
	double r;
	r = Math.sqrt(sqr(x-0.5) + sqr(y-0.5) + sqr(z-0.5));
	if (r > 1e-4)
	    return h(r)/r;
	else
	    return 0.0;
    }

    public double psi(double x,double y,double z){
	double r;
	r = Math.sqrt(sqr(x-0.5) + sqr(y-0.5) + sqr(z-0.5));
	if (r > 1e-4)
	    return -1.0*dh(r)/r;
	else
	    return 0.0;
    }

    public double sqr(double x){
	return x*x;
    }

    public double h(double r){
	double a = 0.1, b = 0.2;
	if (r >= a && r <= b)
	    return 4 * sqr(r-a) * sqr(r-b) / sqr(sqr(b-a));
	else
	    return 0.0;
    }

    public double dh(double r){
	double a = 0.1, b = 0.2;
	if (r >= a && r <= b)
	    return 8.0 * (r-a) * (r-b) * (2*r-a-b) / sqr(sqr(b-a));
	else
	    return 0.0;
    }
}
