/**  ư򤯥ץࡣ
 * 
 *   bc=0    Dirichlet 
 *   bc=1    Neumann   
 *   bc=2    ʻѤˡ
 *
 *   򥳥ѥ뤹ˤMitsuiWorldɬפǤ
 *   MitsuiWorldȤ֤Ǥ̤Υѥ javac Wave1d.java
 *   ̤εưˡ appletviewer Wave1d.java 
 *   ǣϣˡ
 *    appletviewer Wave1d.java ȤХΤɤ
 *   
 *   <applet code = Wave2d width=500 height=500></applet>
 *   
 *   ȤΤäƤʤȤʤ
 *   MitsuiWorldλȤˤäƤ
 *
 *   import Mitsui.*;
 *
 *   äȡ
 *   MitsuiWorldѥåȤƻȤʤͤϤäƤ
 *
 */

import java.applet.*;
import java.awt.*;
import Mitsui.*;       //MitsuiWorldäƤѥåMitsuiƤӽФ

public class Wave2d extends Applet {
    int nfunc=0;                    //ǤʤδؿȽǤ롣
    int bc=0;                       //ǤʤζȽǤ롣
    MitsuiWorld_2 m = new MitsuiWorld_2();
    double xmin,xmax,ymin,ymax,zmin,zmax;

    public void init(){
        Graphics g=getGraphics();
        m.setGraphics(g);
        m.setScreenSize(getSize().width,getSize().height);
        //ΣᡤϡߡΣ㡤ϡߡΣ塤
        xmin=-2.0;
        xmax=2.0;
        ymin=-2.0;
        ymax=2.0;
        zmin=-1.0;
        zmax=1.0;
        m.setArea2(xmin,xmax,ymin,ymax,zmin,zmax);
        m.setColor(3);                  //դο
    }

    public void paint(Graphics g){
        
        int nx = 40;                  //xʬ礭ư٤
        int ny = 40;                  //yʬ礭ư٤
        double tau = 0.05;            //ֹ 
        double Tmax = 4.0;            //礭֤Ĺʤ
        
        double dx = (xmax-xmin)/nx;
        double dy = (ymax-ymin)/ny;
        double lambdax = tau / dx;
        double lambday = tau / dy;
        double lambdax2 = lambdax * lambdax;
        double lambday2 = lambday * lambday;         
        
        double[][] u1 = new double[nx+1][ny+1];
        double[][] u2 = new double[nx+1][ny+1];
        double[][] u3 = new double[nx+1][ny+1];

        //
        //phi=
        //psi=
        for(int i=0;i<=nx;i++)
            for(int j=0;j<=ny;j++)
                u1[i][j] = phi(xmin+i*dx,ymin+j*dy); 
        for(int i=1;i<nx;i++)
            for(int j=1;j<ny;j++)
                u2[i][j] = (1.0-lambdax2-lambday2) * u1[i][j] + 
                    0.5 * lambdax2 * (u1[i-1][j]+u1[i+1][j]) +
                    0.5 * lambday2 * (u1[i][j-1]+u1[i][j+1]) +
                    tau * psi(xmin+i*dx,ymin+j*dy);

        if(bc==0){                                 //Dirichlet
            for(int i=0;i<=nx;i++)
                u2[i][0]=u2[i][ny]=0.0;
            for(int i=0;i<=ny;i++)
                u2[0][i]=u2[nx][i]=0.0;
        }
        if(bc==1){                                //Neumann
            for(int i=0;i<=nx;i++){
                u2[i][0]=u2[i][1];
                u2[i][ny]=u2[i][ny-1];
            }
            for(int i=0;i<=ny;i++){
                u2[0][i]=u2[1][i];
                u2[nx][i]=u2[nx-1][i];
            }
        }
        if(bc==2){                               //ʻ
            for(int i=1;i<nx;i++){
                u2[i][0]=(1.0-lambdax2-lambday2) * u1[i][0] + 
                    0.5 * lambdax2 * (u1[i-1][0]+u1[i+1][0]) +
                    0.5 * lambday2 * (2*u1[i][1]) +
                    tau * psi(xmin+i*dx,ymin);
                u2[i][ny]=(1.0-lambdax2-lambday2) * u1[i][ny] + 
                    0.5 * lambdax2 * (u1[i-1][ny]+u1[i+1][ny]) +
                    0.5 * lambday2 * (2*u1[i][ny-1]) +
                    tau * psi(xmin+i*dx,ymin+ny*dy);
            }
            for(int j=1;j<ny;j++){
                u2[0][j]=(1.0-lambdax2-lambday2) * u1[0][j] + 
                    0.5 * lambdax2 * (2*u1[1][j]) +
                    0.5 * lambday2 * (u1[0][j-1]+u1[0][j+1]) +
                    tau * psi(xmin,ymin+j*dy);
                u2[nx][j]=(1.0-lambdax2-lambday2) * u1[nx][j] + 
                    0.5 * lambdax2 * (2*u1[nx-1][j]) +
                    0.5 * lambday2 * (u1[nx][j-1]+u1[nx][j+1]) +
                    tau * psi(xmin+nx*dx,ymin+j*dy);
            }
            u2[0][0]=(1.0-lambdax2-lambday2) * u1[0][0] + 
                0.5 * lambdax2 * (2*u1[1][0]) +
                0.5 * lambday2 * (2*u1[0][1]) +
                tau * psi(xmin,ymin);
            u2[nx][0]=(1.0-lambdax2-lambday2) * u1[nx][0] + 
                0.5 * lambdax2 * (2*u1[nx-1][0]) +
                0.5 * lambday2 * (2*u1[nx][1]) +
                tau * psi(xmin+nx*dx,ymin);
            u2[0][ny]=(1.0-lambdax2-lambday2) * u1[0][ny] + 
                0.5 * lambdax2 * (2*u1[1][ny]) +
                0.5 * lambday2 * (u1[0][ny-1]) +
                tau * psi(xmin,ymin+ny*dy);
            u2[nx][ny]=(1.0-lambdax2-lambday2) * u1[nx][ny] + 
                0.5 * lambdax2 * (2*u1[nx-1][ny]) +
                0.5 * lambday2 * (2*u1[nx][ny-1]) +
                tau * psi(xmin+nx*dx,ymin+ny*dy);
            
        }
        
        //t=0ǤΥ
        m.hideBirdView(u1,nx,ny,1);
                
        //t=0ǤΥդ򤱤
        g.clearRect(0,30,getSize().width,getSize().height);
        
        //t=ӤǤΥ
        m.hideBirdView(u2,nx,ny,1);
                
        int kmax = (int)Math.rint(Tmax/tau);
        for(int k=1;k<=kmax;k++){
            for(int i=1;i<nx;i++)
                for(int j=1;j<ny;j++)
                    u3[i][j] = 2 * (1.0-lambdax2 -lambday2) * u2[i][j] + 
                        lambdax2 * (u2[i-1][j]+u2[i+1][j]) +
                        lambday2 * (u2[i][j-1]+u2[i][j+1]) - u1[i][j];
            
            if(bc==0){                           //Dirichlet
                for(int i=0;i<=nx;i++)
                    u3[i][0] = u3[i][ny] = 0;
                for(int i=0;i<=ny;i++)
                    u3[0][i] = u3[nx][i] = 0;
            }
            if(bc==1){                          //Neumann 
                for(int i=0;i<=nx;i++){
                    u3[i][0] = u3[i][1] ;
                    u3[i][ny]= u3[i][ny-1];
                }
                for(int i=0;i<=ny;i++){
                    u3[0][i] = u3[1][i];
                    u3[nx][i]= u3[nx-1][i];
                }
            }
            if(bc==2){                          //۳ʻ
                for(int i=1;i<nx;i++){
                    u3[i][0] = 2 * (1.0-lambdax2 -lambday2) * u2[i][0] + 
                        lambdax2 * (u2[i-1][0]+u2[i+1][0]) +
                        lambday2 * (2*u2[i][1]) - u1[i][0];
                    u3[i][ny]=  2 * (1.0-lambdax2 -lambday2) * u2[i][ny] + 
                        lambdax2 * (u2[i-1][ny]+u2[i+1][ny]) +
                        lambday2 * (2*u2[i][ny-1]) - u1[i][ny];
                }
                for(int j=1;j<ny;j++){
                    u3[0][j] = 2 * (1.0-lambdax2 -lambday2) * u2[0][j] + 
                        lambdax2 * (2*u2[1][j]) +
                        lambday2 * (u2[0][j-1]+u2[0][j+1]) - u1[0][j];
                    u3[nx][j]= 2 * (1.0-lambdax2 -lambday2) * u2[nx][j] + 
                        lambdax2 * (2*u2[nx-1][j]) +
                        lambday2 * (u2[nx][j-1]+u2[nx][j+1]) - u1[nx][j];
                }
                u3[0][0] = 2 * (1.0-lambdax2 -lambday2) * u2[0][0] + 
                    lambdax2 * (2*u2[1][0]) +
                    lambday2 * (2*u2[0][1]) - u1[0][0];
                u3[nx][0]= 2 * (1.0-lambdax2 -lambday2) * u2[nx][0] + 
                    lambdax2 * (2*u2[nx-1][0]) +
                    lambday2 * (2*u2[nx][1]) - u1[nx][0];
                u3[0][ny]= 2 * (1.0-lambdax2 -lambday2) * u2[0][ny] + 
                    lambdax2 * (2*u2[1][ny]) +
                    lambday2 * (2*u2[0][ny-1]) - u1[0][ny];
                u3[nx][ny]= 2 * (1.0-lambdax2 -lambday2) * u2[nx][ny] + 
                    lambdax2 * (2*u2[nx-1][ny]) +
                    lambday2 * (2*u2[nx][ny-1]) - u1[nx][ny];
            }
            
            //դä
            g.clearRect(0,30,getSize().width,getSize().height);
            
            //t=k(k>=2)Υդ
            m.hideBirdView(u3,nx,ny,1);
            
            //u1u2ͤu2u3ͤ
            for(int i=0;i<=nx;i++){
                for(int j=0;j<=ny;j++){
                    u1[i][j] = u2[i][j];
                    u2[i][j] = u3[i][j];
                }
            }
        }
    }
    
    public double phi(double x,double y){
        double cx=(xmax+xmin)/2;
        double cy=(ymax+ymin)/2;
        double r =(xmax-xmin)/5;

        if(nfunc==0){
            return Math.sin(Math.PI*x)/2+Math.sin(Math.PI*y)/2;
        }
        if(nfunc==1){
            if((x-cx)*(x-cx)+(y-cy)*(y-cy)<=r*r)
                return Math.sqrt(r*r-(x-cx)*(x-cx)-(y-cy)*(y-cy));
            else
                return 0.0;
        }
        if(nfunc==2){
            if(xmin<=x && x<=xmin+1)
                return (Math.sin(Math.PI*(x*2-0.5))+1)/4;
            else 
                return 0.0;
        }
        if(nfunc == 3){
            if(xmin<=x && x<=xmin+1)
                return (Math.sin(Math.PI*(x*2-0.5))+1)/4;
            if(xmax-1<=x && x<=xmax)
                return (Math.sin(Math.PI*((x-xmax+1)*2-0.5))+1)/6;
            else
                return 0.0;
        }
        if(nfunc==4){
            if(x*x+y*y<1)
                return ((Math.cos(Math.PI*x)+Math.cos(Math.PI*y))+1)/2;
            else
                return 0.0;
        }
        else
            return 0.0;
    }
    
    //
    public double psi(double x,double y){
        double cx=(xmax+xmin)/2;
        double cy=(ymax+ymin)/2;
        double r =(xmax-xmin)/5;

        if(nfunc==2){
            if(xmin<=x && x<=xmin+1)
                return -2*Math.PI*Math.cos(Math.PI*(x*2-0.5))/4;
            else
                return 0.0;
        }
        if(nfunc == 3){
            if(xmin<=x && x<=xmin+1)
                return -2*Math.PI*Math.cos(Math.PI*(x*2-0.5))/4;
            if(xmax-1<=x && x<=xmax)
                return 2*Math.PI*Math.cos(Math.PI*((x-xmax+1)*2-0.5))/6;
            else
                return 0.0;
        }
        else
            return 0.0;
    } 
}






